/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * xesam-glib
 * Copyright (C) Mikkel Kamstrup Erlandsen 2008 <mikkel.kamstrup@gmail.com>
 * 
 * xesam-glib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * xesam-glib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with xesam-glib.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#if defined(XESAM_GLIB_ENABLE_SINGLE_INCLUDES) && !defined (_XESAM_GLIB_H_) && !defined (XESAM_GLIB_COMPILATION)
#error "Only <xesam-glib.h> can be included directly."
#endif

#ifndef _XESAM_G_DBUS_SEARCHER_STUB_H_
#define _XESAM_G_DBUS_SEARCHER_STUB_H_

#include <glib-object.h>

G_BEGIN_DECLS

#define XESAM_TYPE_G_DBUS_SEARCHER_STUB             (xesam_g_dbus_searcher_stub_get_type ())
#define XESAM_G_DBUS_SEARCHER_STUB(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), XESAM_TYPE_G_DBUS_SEARCHER_STUB, XesamGDBusSearcherStub))
#define XESAM_G_DBUS_SEARCHER_STUB_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), XESAM_TYPE_G_DBUS_SEARCHER_STUB, XesamGDBusSearcherStubClass))
#define XESAM_IS_G_DBUS_SEARCHER_STUB(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XESAM_TYPE_G_DBUS_SEARCHER_STUB))
#define XESAM_IS_G_DBUS_SEARCHER_STUB_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), XESAM_TYPE_G_DBUS_SEARCHER_STUB))
#define XESAM_G_DBUS_SEARCHER_STUB_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), XESAM_TYPE_G_DBUS_SEARCHER_STUB, XesamGDBusSearcherStubClass))

/* Public structs */
typedef struct _XesamGDBusSearcherStub XesamGDBusSearcherStub;
typedef struct _XesamGDBusSearcherStubClass XesamGDBusSearcherStubClass;

/* Private structs */
typedef struct _XesamGDBusSearcherStubPrivate XesamGDBusSearcherStubPrivate;

struct _XesamGDBusSearcherStubClass
{
	GObjectClass parent_class;
};

struct _XesamGDBusSearcherStub
{
	GObject 						parent_instance;
	XesamGDBusSearcherStubPrivate 	*priv;
};

/* Public methods */
GType 			 xesam_g_dbus_searcher_stub_get_type	(void) G_GNUC_CONST;	

XesamGDBusSearcherStub*
				xesam_g_dbus_searcher_stub_new			(XesamGSearcher			*searcher);

void			xesam_g_dbus_searcher_stub_export
														(XesamGDBusSearcherStub *stub,
														 const	gchar			*object_path,
														 GError					**error);

void			xesam_g_dbus_searcher_stub_register_bus_name
														(const gchar			*bus_name,
														 GError 				**error);

void			xesam_g_dbus_searcher_stub_release_bus_name
														(const gchar			*bus_name,
														 GError 				**error);

G_END_DECLS

#endif /* _XESAM_G_DBUS_SEARCHER_STUB_H_ */
